import { notFound } from "next/navigation"

import { dt } from "@/lib/dt"
import {
  getHotelData,
  getLocations,
  getProfileSafely,
} from "@/lib/trpc/memoizedRequests"
import { serverClient } from "@/lib/trpc/server"

import HotelInfoCard from "@/components/HotelReservation/SelectRate/HotelInfoCard"
import Rooms from "@/components/HotelReservation/SelectRate/Rooms"
import {
  generateChildrenString,
  getHotelReservationQueryParams,
} from "@/components/HotelReservation/SelectRate/RoomSelection/utils"
import { setLang } from "@/i18n/serverContext"

import { RoomPackageCodeEnum } from "@/types/components/hotelReservation/selectRate/roomFilter"
import type { SelectRateSearchParams } from "@/types/components/hotelReservation/selectRate/selectRate"
import type { LangParams, PageArgs } from "@/types/params"

export default async function SelectRatePage({
  params,
  searchParams,
}: PageArgs<LangParams & { section: string }, SelectRateSearchParams>) {
  setLang(params.lang)

  const locations = await getLocations()
  if (!locations || "error" in locations) {
    return null
  }
  const hotel = locations.data.find(
    (location) =>
      "operaId" in location && location.operaId == searchParams.hotel
  )
  if (!hotel) {
    return notFound()
  }
  const selectRoomParams = new URLSearchParams(searchParams)
  const selectRoomParamsObject =
    getHotelReservationQueryParams(selectRoomParams)

  if (!selectRoomParamsObject.room) {
    return notFound()
  }

  const validFromDate =
    searchParams.fromDate &&
    dt(searchParams.fromDate).isAfter(dt().subtract(1, "day"))
      ? searchParams.fromDate
      : dt().utc().format("YYYY-MM-DD")
  const validToDate =
    searchParams.toDate && dt(searchParams.toDate).isAfter(validFromDate)
      ? searchParams.toDate
      : dt().utc().add(1, "day").format("YYYY-MM-DD")
  const adults = selectRoomParamsObject.room[0].adults || 1 // TODO: Handle multiple rooms
  const childrenCount = selectRoomParamsObject.room[0].child?.length
  const children = selectRoomParamsObject.room[0].child
    ? generateChildrenString(selectRoomParamsObject.room[0].child)
    : undefined // TODO: Handle multiple rooms

  const [hotelData, roomsAvailability, packages, user] = await Promise.all([
    getHotelData({ hotelId: searchParams.hotel, language: params.lang }),
    serverClient().hotel.availability.rooms({
      hotelId: parseInt(searchParams.hotel, 10),
      roomStayStartDate: validFromDate,
      roomStayEndDate: validToDate,
      adults,
      children,
    }),
    serverClient().hotel.packages.get({
      hotelId: searchParams.hotel,
      startDate: searchParams.fromDate,
      endDate: searchParams.toDate,
      adults,
      children: childrenCount,
      packageCodes: [
        RoomPackageCodeEnum.ACCESSIBILITY_ROOM,
        RoomPackageCodeEnum.PET_ROOM,
        RoomPackageCodeEnum.ALLERGY_ROOM,
      ],
    }),
    getProfileSafely(),
  ])

  if (!roomsAvailability) {
    return "No rooms found" // TODO: Add a proper error message
  }

  if (!hotelData) {
    return "No hotel data found" // TODO: Add a proper error message
  }

  const roomCategories = hotelData?.included

  const noRoomsAvailable = roomsAvailability.roomConfigurations.reduce(
    (acc, room) => {
      return acc && room.status === "NotAvailable"
    },
    true
  )

  return (
    <>
      <HotelInfoCard hotelData={hotelData} noAvailability={noRoomsAvailable} />
      <Rooms
        roomsAvailability={roomsAvailability}
        roomCategories={roomCategories ?? []}
        user={user}
        packages={packages ?? []}
      />
    </>
  )
}
